isOctave = exist('OCTAVE_VERSION', 'builtin') ~= 0;
if(isOctave)
   pkg load image; 
end
    
disp("");
disp("====================");
disp("Results for Figure 2");
disp("--------------------");

A=imread('gray/gray000.png');
B=imread('gray/gray255.png');
if(isOctave)
  B =B .* 255;  % for some reason, this image contains ones when reading with Octave, so multiplying with 255
end
[mssim_simplified, mssim, ssim_map_simplified, ssim_map, l_map, c_map, s_map] = ssimlcs(A,B);
disp("MSSIM between black and white images");
mssim_simplified
float2grayred(ssim_map, 'result_images/luminance_minimum_ssim.png', 1);
float2grayred(l_map, 'result_images/luminance_minimum_L.png', 1);
float2grayred(c_map, 'result_images/luminance_minimum_C.png', 1);
float2grayred(s_map, 'result_images/luminance_minimum_S.png', 1);
disp("--------------------");

A=imread('gray/gray128.png');
B=imread('checker/checker-bw.png');
if(isOctave)
  B =B .* 255;  % for some reason, this image contains ones when reading with Octave, so multiplying with 255
end
[mssim_simplified, mssim, ssim_map_simplified, ssim_map, l_map, c_map, s_map] = ssimlcs(A,B);
disp("MSSIM between gray (128/255) and a checkered image (black and white)");
mssim_simplified
float2grayred(ssim_map, 'result_images/contrast_minimum_ssim.png', 1);
float2grayred(l_map, 'result_images/contrast_minimum_L.png', 1);
float2grayred(c_map, 'result_images/contrast_minimum_C.png', 1);
float2grayred(s_map, 'result_images/contrast_minimum_S.png', 1);
disp("--------------------");

A=imread('checker/checker-bw.png');
B=imread('checker/checker-wb.png');
if(isOctave)
  A =A .* 255;  % for some reason, this image contains ones when reading with Octave, so multiplying with 255
  B =B .* 255;  % for some reason, this image contains ones when reading with Octave, so multiplying with 255
end

[mssim_simplified, mssim, ssim_map_simplified, ssim_map, l_map, c_map, s_map] = ssimlcs(A,B);
disp("MSSIM between gray checker and inverted checkerboard");
mssim_simplified
float2grayred(ssim_map, 'result_images/structure_minimum_ssim.png', 1);
float2grayred(l_map, 'result_images/structure_minimum_L.png', 1);
float2grayred(c_map, 'result_images/structure_minimum_C.png', 1);
float2grayred(s_map, 'result_images/structure_minimum_S.png', 1);
disp("====================");
