isOctave = exist('OCTAVE_VERSION', 'builtin') ~= 0;
if(isOctave)
    pkg load image;
end
disp("");
disp("====================");
disp("Results for Figure 5");
disp("--------------------");

A = imread('color/cyan255.png');
B = imread('color/cyan143.png');
if(isOctave)
  A = A .* 255;  % for some reason, this image contains ones when reading with Octave, so multiplying with 255
end
Al = rgb2gray(A);
Bl = rgb2gray(B);
[mssim, ssim_map] = ssim(Al, Bl);
disp("MSSIM when comparing a white image to a cyan (143,255,255) image using 0.298936*R + 0.587043*G + 0.114021*B");
mssim
disp("--------------------");


A = imread('color/magenta255.png');
B = imread('color/magenta198.png');
if(isOctave)
  A = A .* 255;  % for some reason, this image contains ones when reading with Octave, so multiplying with 255
end
Al = rgb2gray(A);
Bl = rgb2gray(B);
[mssim, ssim_map] = ssim(Al, Bl);
disp("MSSIM when comparing a white image to a magenta (255,198,255) image using 0.298936*R + 0.587043*G + 0.114021*B");
mssim
disp("--------------------");

A = imread('color/yellow255.png');
B = imread('color/yellow000.png');
if(isOctave)
  A = A .* 255;  % for some reason, this image contains ones when reading with Octave, so multiplying with 255
  B = B .* 255;  % for some reason, this image contains ones when reading with Octave, so multiplying with 255
end
Al = rgb2gray(A);
Bl = rgb2gray(B);
[mssim, ssim_map] = ssim(Al, Bl);
disp("MSSIM when comparing a white image to a yellow (255,255,0) image using 0.298936*R + 0.587043*G + 0.114021*B");
mssim

disp("====================");

