isOctave = exist('OCTAVE_VERSION', 'builtin') ~= 0;
if(isOctave)
    pkg load image;
end

disp("");
disp("====================");
disp("Results for Figure 6");
disp("--------------------");

A=imread('gradients/perfect_gradient_bw_256x256.png');
B=imread('gradients/perfect_gradient_wb_256x256.png');
[mssim, ssim_map] = ssim(A,B);
disp("MSSIM between opposite gradients at 256x256 pixels: ");
mssim
float2grayred(ssim_map, 'result_images/perfect_gradient_ssim_256x256_1x.png', 1);
disp("--------------------");
 
A=imread('gradients/perfect_gradient_bw_64x64.png');
B=imread('gradients/perfect_gradient_wb_64x64.png');
[mssim, ssim_map] = ssim(A,B);
disp("MSSIM between opposite gradients at 64x64 pixels: ");
mssim
float2grayred(ssim_map, 'result_images/perfect_gradient_ssim_64x64_1x.png', 1);
disp("--------------------");
 
A=imread('gradients/perfect_gradient_bw_16x16.png');
B=imread('gradients/perfect_gradient_wb_16x16.png');
[mssim, ssim_map] = ssim(A,B);
disp("MSSIM between opposite gradients at 16x16 pixels: ");
mssim
float2grayred(ssim_map, 'result_images/perfect_gradient_ssim_16x16_1x.png', 1);
disp("====================");
